﻿using System;
using System.IO.Ports;
using System.Windows.Forms;
using System.Configuration;
using ToolSystem;

namespace ReadRfidApp
{
    public partial class Form1 : Form
    {

        string connectionString = ConfigurationManager.ConnectionStrings["DatabaseConnectionString"].ConnectionString;

        string rfidTag;
        string rfidTagPrevious="";
        string personTag;
        string toolTag;
        

        SerialPort port = new System.IO.Ports.SerialPort("COM4", 2400, System.IO.Ports.Parity.None, 8, System.IO.Ports.StopBits.One);

        public Form1()
        {
            InitializeComponent();

            port.Open();
            port.DtrEnable = true;

            timer1.Interval = 1000;
            timer1.Start();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
        }

        private void Form1_UnLoad(object sender, EventArgs e)
        {
            port.Close();
        }



        private void timer1_Tick(object sender, EventArgs e)
        {
            ReadTag();
        }

        private void ReadTag()
        {
            int numberBytesToRead = 12;
            byte[] data = new byte[numberBytesToRead];
            port.ReadTimeout = 100;

            try
            {
                port.Read(data, 0, numberBytesToRead);
                rfidTag = System.Text.Encoding.UTF8.GetString(data, 0, data.Length);

                

                rfidTag = rfidTag.Replace("\n", "");
                rfidTag = rfidTag.Replace("\r", "");


                if (data.Length == 12 && rfidTag!= rfidTagPrevious)
                { 
                    if (rfidTag == "0800296663") //The RFIDTag is a User ID Card
                    {
                        Login();
                    }
                    else //The RFIDTag is a Tool
                    {
                        GetTool();
                    }

                    rfidTagPrevious = rfidTag;
                }
            }
            catch { }


        }


        private void Login()
        {
            Rfid rfid = new Rfid();
            string personName;

            personTag = rfidTag;
            txtLoginData.Text = personTag;
            
            personName = rfid.GetPersonName(connectionString, personTag);

            if (personName == "")
            {
                lblStatusField.Text = "This is not a legal ID Card! Try with another ID Card.";
            }
            else
            {
                txtLoginData.Text = personName;
                lblStatusField.Text = "You are logged in";
                toolTag = "";
                txtToolTag.Text = "";
                txtToolName.Text = "";
            }

        }


        private void GetTool()
        {       
            string toolName = "";

            toolTag = rfidTag;

            Rfid rfid = new Rfid();
            toolName = rfid.GetToolName(connectionString, toolTag);

            txtToolTag.Text = toolTag;

            if (toolName == "")
            {
                lblStatusField.Text = "This RFID Tag is not legal! Try once more";
            }
            else
            {
                txtToolName.Text = toolName;
                lblStatusField.Text = "Valid RFID Tag";
                SetToolStatus();
            }
        }

        private void SetToolStatus()
        {

            if (personTag!=null && toolTag!=null)
            {
                Rfid rfid = new Rfid();
                rfid.SetToolStatus(connectionString, personTag, toolTag);

                lblStatusField.Text = "Status for " + txtToolName.Text + " has been updated";
            }


        }
    }
}
