using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Http;
using ToolSystem;


namespace Tool_Management.Pages
{
    public class EditToolModel : PageModel
    {
        readonly IConfiguration _configuration;

        public Tool tooldb = new Tool();

        public string connectionString;

        public int toolId;

        public string userName = null;
        public int validUser = 0;

        public EditToolModel(IConfiguration configuration)
        {
            _configuration = configuration;
        }

        public void OnGet()
        {
            VerifyLogin();

            toolId = Convert.ToInt16(Request.Query["toolid"]);

            Tool tool = new Tool();

            connectionString = _configuration.GetConnectionString("ConnectionString");

            tooldb = tool.GetToolData(connectionString, toolId);
        }

        public void OnPost()
        {
            Tool tool = new Tool();

            tool.ToolId = Convert.ToInt16(Request.Form["ToolId"]);
            tool.ToolName = Request.Form["ToolName"];
            tool.ToolTag = Request.Form["ToolTag"];
            tool.ToolDescription = Request.Form["ToolDescription"];

            connectionString = _configuration.GetConnectionString("ConnectionString");

            tool.EditTool(connectionString, tool);

            Response.Redirect("./ToolList");
        }

        void VerifyLogin()
        {

            if (HttpContext.Session.GetInt32("Login") != null)
                validUser = (int)HttpContext.Session.GetInt32("Login");
            else
                validUser = 0;

            if (HttpContext.Session.GetString("UserName") != null)
                userName = HttpContext.Session.GetString("UserName");
            else
                userName = null;

        }
    }
}
