using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Http;
using ToolSystem;

namespace Tool_Management.Pages
{
    public class LoginModel : PageModel
    {
        readonly IConfiguration _configuration;

        private string connectionString;

        public string userName = null;
        public bool validUser = false;

        public LoginModel(IConfiguration configuration)
        {
            _configuration = configuration;

        }
        public void OnGet()
        {
        }

        public void OnPost()
        {
            CheckLogin();
        }

        void CheckLogin()
        {
            string password;

            userName = Request.Form["EMail"];
            password = Request.Form["Password"];

            Login login = new Login();

            connectionString = _configuration.GetConnectionString("ConnectionString");

            validUser = login.CheckPassword(connectionString, userName, password);

            if (validUser == true)
            {
                HttpContext.Session.SetInt32("Login", 1);
                HttpContext.Session.SetString("UserName", userName);
                Response.Redirect("./Index");
            }
            else
            {
                HttpContext.Session.SetInt32("Login", 0);
                HttpContext.Session.SetString("UserName", "");
                Response.Redirect("./User");
            }

        }
    }
}
