using System;
using System.Collections.Generic;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.AspNetCore.Http;
using ToolSystem;

namespace Tool_Management.Pages
{
    public class PersonListModel : PageModel
    {
        readonly IConfiguration _configuration;

        public List<Person> persons = new List<Person>();

        public string connectionString;

        public string userName = null;
        public int validUser = 0;

        public PersonListModel(IConfiguration configuration)
        {
            _configuration = configuration;
        }

        public void OnGet()
        {
            VerifyLogin();

            persons = GetPersonList();
        }

        void VerifyLogin()
        {

            if (HttpContext.Session.GetInt32("Login") != null)
                validUser = (int)HttpContext.Session.GetInt32("Login");
            else
                validUser = 0;

            if (HttpContext.Session.GetString("UserName") != null)
                userName = HttpContext.Session.GetString("UserName");
            else
                userName = null;

        }

        private List<Person> GetPersonList()
        {
            connectionString = _configuration.GetConnectionString("ConnectionString");

            List<Person> personList = new List<Person>();

            Person person = new Person();

            personList = person.GetPersons(connectionString);

            return personList;
        }
    }
}
