using System;
using System.Collections.Generic;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.AspNetCore.Http;

using ToolSystem;

namespace Tool_Management.Pages
{
    public class ToolListModel : PageModel
    {
        readonly IConfiguration _configuration;

        public List<Tool> tools = new List<Tool>();

        public string connectionString;

        public string userName = null;
        public int validUser = 0;

        public ToolListModel(IConfiguration configuration)
        {
            _configuration = configuration;
        }

        public void OnGet()
        {
            VerifyLogin();

            tools = GetToolList();
        }

        void VerifyLogin()
        {

            if (HttpContext.Session.GetInt32("Login") != null)
                validUser = (int)HttpContext.Session.GetInt32("Login");
            else
                validUser = 0;

            if (HttpContext.Session.GetString("UserName") != null)
                userName = HttpContext.Session.GetString("UserName");
            else
                userName = null;

        }

        private List<Tool> GetToolList()
        {
            connectionString = _configuration.GetConnectionString("ConnectionString");

            List<Tool> toolList = new List<Tool>();

            Tool tool = new Tool();

            toolList = tool.GetTools(connectionString);

            return toolList;
        }
    }
}
